cscripts.obutils.residuals may have a floating-point math glitch
11/29/2018 01:56 AM - Kelley-Hoskins Nathan
Description

I've been looking at the statistics of csresmap when using algorithm='SIGNIFICANCE' (calculated here), and | ran into something odd
when recreating the calculation in my python script.

The situation is: you're calculating the significance of a bin that has 7 observed counts, and 6.9999999999999... modeled counts
(7-<a really small numbers).

$ python

>>>d=7

>>>m=d-1e-14

>>> print(sqrt(d*log(d/m) + m - d))

Traceback (most recent call last):
File "<stdin>", line 1, in <module>

ValueError: math domain error

>>> d*log(d/m) + m - d

-8.881784197001252e-16

When calculating the significance (done here in csresmap), the value of
d*log(d/m) + m - d

becomes negative, and then the sqgrt() throws an exception, ruining your wednesday night statistical experiments. | think its due to
how python handles long floating point numbers, but I'm not sure.

Just to emphasize, | haven't actually seen this happen yet in csresmap since | don't have enough time to test it out. But | did see this
when doing the same calculation with some MC statistical sims in a standalone python script, so I'm marking this as low priority, but it
may be worth checking out.

History

#1 - 11/29/2018 01:59 AM - Kelley-Hoskins Nathan

*The next thing that's done with that negative number is square-rooted, which is where the sqrt() comes in.

#2 - 07/15/2020 10:00 PM - Knodlseder Jiirgen
- Status changed from New to Pull request

- Assigned To set to Knédlseder Jiirgen

- Target version set to 1.7.0

- % Done changed from 0 to 100

Thanks for pointing this out. This looks indeed like a numerical glitch. | force now negative residual values in obsutils.residual() to zero so that no
square root error will occur.

#3 - 07/15/2020 10:15 PM - Knodlseder Jiirgen

- Status changed from Pull request to Closed

04/17/2024 1/2



https://cta-gitlab.irap.omp.eu/ctools/ctools/blob/devel/cscripts/obsutils.py#L906
https://cta-gitlab.irap.omp.eu/ctools/ctools/blob/devel/cscripts/obsutils.py#L907

Merged into devel.
